unit Events;

{ Pascal Interface to the Macintosh Libraries }

{ Copyright  Apple Computer Inc. }
{ All Rights Reserved }

{ Adapted for use with THINK Pascal 4.0.x by Marco Piovanelli }

interface
	uses
		Types;

	type
		EventKind = UInt16;
		EventMask = UInt16;
		EventModifiers = UInt16;

	type
		GetNextEventFilterProcPtr = ProcPtr;  { PROCEDURE GetNextEventFilter(VAR theEvent: EventRecord; VAR result: BOOLEAN); }
		GetNextEventFilterUPP = UniversalProcPtr;

	const
		uppGetNextEventFilterProcInfo = $000000BF; { SPECIAL_CASE_PROCINFO( kSpecialCaseGNEFilterProc ) }

	function NewGetNextEventFilterProc (userRoutine: GetNextEventFilterProcPtr): GetNextEventFilterUPP;
	inline
		$2E9F;

	procedure CallGetNextEventFilterProc (var theEvent: EventRecord;
									var result: BOOLEAN;
									userRoutine: GetNextEventFilterUPP);
{To be implemented:  Glue to move parameters according to special case conventions.}

	type
		GNEFilterUPP = GetNextEventFilterUPP;

		FKEYProcPtr = ProcPtr;		{ PROCEDURE FKEY; }
		FKEYUPP = UniversalProcPtr;

	const
		uppFKEYProcInfo = $00000000;  { PROCEDURE ; }

	function NewFKEYProc (userRoutine: FKEYProcPtr): FKEYUPP;
	inline
		$2E9F;

	procedure CallFKEYProc (userRoutine: FKEYUPP);
	inline
		$205F, $4E90;

	function KeyTranslate (transData: univ Ptr;
									keycode: INTEGER;
									var state: LONGINT): LONGINT;
	inline
		$A9C3;

implementation
end.