unit FixMath;

{ Pascal Interface to the Macintosh Libraries }

{ Copyright  Apple Computer Inc. }
{ All Rights Reserved }

{ Adapted for use with THINK Pascal 4.0.x by Marco Piovanelli }

interface
	uses
		Types;

	const
		fixed1 = $00010000;
		fract1 = $40000000;
		positiveInfinity = $7FFFFFFF;
		negativeInfinity = $80000000;


	function Fix2Frac (x: Fixed): Fract;
	inline
		$A841;
	function Fix2Long (x: Fixed): LONGINT;
	inline
		$A840;
	function Long2Fix (x: LONGINT): Fixed;
	inline
		$A83F;
	function Frac2Fix (x: Fract): Fixed;
	inline
		$A842;
	function FracMul (x: Fract;
									y: Fract): Fract;
	inline
		$A84A;
	function FixDiv (x: Fixed;
									y: Fixed): Fixed;
	inline
		$A84D;
	function FracDiv (x: Fract;
									y: Fract): Fract;
	inline
		$A84B;
	function FracSqrt (x: Fract): Fract;
	inline
		$A849;
	function FracSin (x: Fixed): Fract;
	inline
		$A848;
	function FracCos (x: Fixed): Fract;
	inline
		$A847;
	function FixATan2 (x: LONGINT;
									y: LONGINT): Fixed;
	inline
		$A818;

{$IFC OPTION(MC68881) }
	function Frac2X (x: Fract): double_t;
	function Fix2X (x: Fixed): double_t;
	function X2Fix (x: double_t): Fixed;
	function X2Frac (x: double_t): Fract;
{$ELSEC}
	function Frac2X (x: Fract): double_t;
	inline
		$A845;
	function Fix2X (x: Fixed): double_t;
	inline
		$A843;
	function X2Fix (x: double_t): Fixed;
	inline
		$A844;
	function X2Frac (x: double_t): Fract;
	inline
		$A846;
{$ENDC}

implementation
end.