unit GestaltEqu;

{ Pascal Interface to the Macintosh Libraries }

{ Copyright  Apple Computer Inc. }
{ All Rights Reserved }

{ Adapted for use with THINK Pascal 4.0.x by Marco Piovanelli }

interface
	uses
		Types;

	type

		SelectorFunctionProcPtr = ProcPtr;  { FUNCTION SelectorFunction(selector: OSType; VAR response: LONGINT): OSErr; }
		SelectorFunctionUPP = UniversalProcPtr;

	const

		uppSelectorFunctionProcInfo = $000003E0; { FUNCTION (4 byte param, 4 byte param): 2 byte result; }

	function NewSelectorFunctionProc (userRoutine: SelectorFunctionProcPtr): SelectorFunctionUPP;
	inline
		$2E9F;

	function CallSelectorFunctionProc (selector: OSType;
									var response: LONGINT;
									userRoutine: SelectorFunctionUPP): OSErr;
	inline
		$205F, $4E90;

	function Gestalt (selector: OSType;
									var response: LONGINT): OSErr;
	inline
		$225F, $201F, $A1AD, $2288, $3E80;

	function NewGestalt (selector: OSType;
									gestaltFunction: SelectorFunctionUPP): OSErr;
	inline
		$205F, $201F, $A3AD, $3E80;

	function ReplaceGestalt (selector: OSType;
									gestaltFunction: SelectorFunctionUPP;
									var oldGestaltFunction: SelectorFunctionUPP): OSErr;
	inline
		$225F, $205F, $201F, $2F09, $A5AD, $225F, $2288, $3E80;

{ These functions are built into System 7.5, but not on earlier systems }

	function NewGestaltValue (selector: OSType;
									newValue: LONGINT): OSErr;
{$IFC NOT UNDEFINED SystemSevenFiveOrLater}
	inline
		$303C, $0401, $ABF1;
{$ENDC}

	function ReplaceGestaltValue (selector: OSType;
									replacementValue: LONGINT): OSErr;
{$IFC NOT UNDEFINED SystemSevenFiveOrLater}
	inline
		$303C, $0402, $ABF1;
{$ENDC}

	function DeleteGestaltValue (selector: OSType): OSErr;
{$IFC NOT UNDEFINED SystemSevenFiveOrLater}
	inline
		$303C, $0203, $ABF1;
{$ENDC}

	function SetGestaltValue (selector: OSType;
									newValue: LONGINT): OSErr;
{$IFC NOT UNDEFINED SystemSevenFiveOrLater}
	inline
		$303C, $0404, $ABF1;
{$ENDC}

implementation
end.