unit Notification;

{ Pascal Interface to the Macintosh Libraries }

{ Copyright  Apple Computer Inc. }
{ All Rights Reserved }

{ Adapted for use with THINK Pascal 4.0.x by Marco Piovanelli }

interface
	uses
		Types;

	type

		NMRec = record
				qLink: QElemPtr;								{next queue entry}
				qType: INTEGER;								{queue type -- ORD(nmType) = 8}
				nmFlags: INTEGER;								{reserved}
				nmPrivate: LONGINT;								{reserved}
				nmReserved: INTEGER;								{reserved}
				nmMark: INTEGER;								{item to mark in Apple menu}
				nmIcon: Handle;									{handle to small icon}
				nmSound: Handle;									{handle to sound record}
				nmStr: StringPtr;								{string to appear in alert}
				nmResp: UniversalProcPtr;						{pointer to response routine}
				nmRefCon: LONGINT;								{for application use}
			end;
		NMRecPtr = ^NMRec;

		NMProcPtr = ProcPtr;  { PROCEDURE NM(nmReqPtr: NMRecPtr); }
		NMUPP = UniversalProcPtr;

	const
		uppNMProcInfo = $000000C0; { PROCEDURE (4 byte param); }

	function NewNMProc (userRoutine: NMProcPtr): NMUPP;
	inline
		$2E9F;

	procedure CallNMProc (nmReqPtr: NMRecPtr;
									userRoutine: NMUPP);
	inline
		$205F, $4E90;

	function NMInstall (nmReqPtr: NMRecPtr): OSErr;
	inline
		$205F, $A05E, $3E80;

	function NMRemove (nmReqPtr: NMRecPtr): OSErr;
	inline
		$205F, $A05F, $3E80;

implementation
end.