 UNIT QDOffscreen;

{ Pascal Interface to the Macintosh Libraries }

{ Copyright  Apple Computer Inc. }
{ All Rights Reserved }

{ Adapted for use with THINK Pascal 4.0.x by Marco Piovanelli }

 INTERFACE

CONST
	pixPurgeBit					= 0;
	noNewDeviceBit				= 1;
	useTempMemBit				= 2;
	keepLocalBit				= 3;
	pixelsPurgeableBit			= 6;
	pixelsLockedBit				= 7;
	mapPixBit					= 16;
	newDepthBit					= 17;
	alignPixBit					= 18;
	newRowBytesBit				= 19;
	reallocPixBit				= 20;
	clipPixBit					= 28;
	stretchPixBit				= 29;
	ditherPixBit				= 30;
	gwFlagErrBit				= 31;

    pixPurge = $00000001;
    noNewDevice = $00000002;
    useTempMem = $00000004;
    keepLocal = $00000008;
    pixelsPurgeable = $00000040;
    pixelsLocked = $00000080;
    mapPix = $00010000;
    newDepth = $00020000;
    alignPix = $00040000;
    newRowBytes = $00080000;
    reallocPix = $00100000;
    clipPix = $10000000;
    stretchPix = $20000000;
    ditherPix = $40000000;
    flagErr = $80000000;

	
TYPE
	GWorldFlags = LONGINT;

{ Type definition of a GWorldPtr }
	GWorldPtr = CGrafPtr;


FUNCTION NewGWorld(VAR offscreenGWorld: GWorldPtr; PixelDepth: INTEGER; {CONST}VAR boundsRect: Rect; cTable: CTabHandle; aGDevice: GDHandle; flags: GWorldFlags): QDErr;
	INLINE $203C, $0016, $0000, $AB1D;
FUNCTION LockPixels(pm: PixMapHandle): BOOLEAN;
	INLINE $203C, $0004, $0001, $AB1D;
PROCEDURE UnlockPixels(pm: PixMapHandle);
	INLINE $203C, $0004, $0002, $AB1D;
FUNCTION UpdateGWorld(VAR offscreenGWorld: GWorldPtr; pixelDepth: INTEGER; {CONST}VAR boundsRect: Rect; cTable: CTabHandle; aGDevice: GDHandle; flags: GWorldFlags): GWorldFlags;
	INLINE $203C, $0016, $0003, $AB1D;
PROCEDURE DisposeGWorld(offscreenGWorld: GWorldPtr);
	INLINE $203C, $0004, $0004, $AB1D;
PROCEDURE GetGWorld(VAR port: CGrafPtr; VAR gdh: GDHandle);
	INLINE $203C, $0008, $0005, $AB1D;
PROCEDURE SetGWorld(port: CGrafPtr; gdh: GDHandle);
	INLINE $203C, $0008, $0006, $AB1D;
PROCEDURE CTabChanged(ctab: CTabHandle);
	INLINE $203C, $0004, $0007, $AB1D;
PROCEDURE PixPatChanged(ppat: PixPatHandle);
	INLINE $203C, $0004, $0008, $AB1D;
PROCEDURE PortChanged(port: GrafPtr);
	INLINE $203C, $0004, $0009, $AB1D;
PROCEDURE GDeviceChanged(gdh: GDHandle);
	INLINE $203C, $0004, $000A, $AB1D;
PROCEDURE AllowPurgePixels(pm: PixMapHandle);
	INLINE $203C, $0004, $000B, $AB1D;
PROCEDURE NoPurgePixels(pm: PixMapHandle);
	INLINE $203C, $0004, $000C, $AB1D;
FUNCTION GetPixelsState(pm: PixMapHandle): GWorldFlags;
	INLINE $203C, $0004, $000D, $AB1D;
PROCEDURE SetPixelsState(pm: PixMapHandle; state: GWorldFlags);
	INLINE $203C, $0008, $000E, $AB1D;
FUNCTION GetPixBaseAddr(pm: PixMapHandle): Ptr;
	INLINE $203C, $0004, $000F, $AB1D;
FUNCTION NewScreenBuffer({CONST}VAR globalRect: Rect; purgeable: BOOLEAN; VAR gdh: GDHandle; VAR offscreenPixMap: PixMapHandle): QDErr;
	INLINE $203C, $000E, $0010, $AB1D;
PROCEDURE DisposeScreenBuffer(offscreenPixMap: PixMapHandle);
	INLINE $203C, $0004, $0011, $AB1D;
FUNCTION GetGWorldDevice(offscreenGWorld: GWorldPtr): GDHandle;
	INLINE $203C, $0004, $0012, $AB1D;
FUNCTION QDDone(port: GrafPtr): BOOLEAN;
	INLINE $203C, $0004, $0013, $AB1D;
FUNCTION OffscreenVersion: LONGINT;
	INLINE $7014, $AB1D;
FUNCTION NewTempScreenBuffer({CONST}VAR globalRect: Rect; purgeable: BOOLEAN; VAR gdh: GDHandle; VAR offscreenPixMap: PixMapHandle): QDErr;
	INLINE $203C, $000E, $0015, $AB1D;
FUNCTION PixMap32Bit(pmHandle: PixMapHandle): BOOLEAN;
	INLINE $203C, $0004, $0016, $AB1D;
FUNCTION GetGWorldPixMap(offscreenGWorld: GWorldPtr): PixMapHandle;
	INLINE $203C, $0004, $0017, $AB1D;

implementation
 END.
