unit Resources;

{ Pascal Interface to the Macintosh Libraries }

{ Copyright  Apple Computer Inc. }
{ All Rights Reserved }

{ Adapted for use with THINK Pascal 4.0.x by Marco Piovanelli }

interface
	uses
		Types;

	type

{		ResErrProcPtr uses register based parameters on the 68k and cannot}
{		be written in or called from a high-level language without the help of}
{		mixed mode or assembly glue.}

{		In:}
{		 => thErr       	D0.W}

		ResErrProcPtr = ProcPtr;  { PROCEDURE ResErr(thErr: OSErr); }
		ResErrUPP = UniversalProcPtr;

	const
		uppResErrProcInfo = $00001002; { Register PROCEDURE (2 bytes in D0); }

	function NewResErrProc (userRoutine: ResErrProcPtr): ResErrUPP;
	inline
		$2E9F;

	procedure CallResErrProc (thErr: OSErr;
									userRoutine: ResErrUPP);
	{To be implemented:  Glue to move parameters into registers.}

	function GetResourceSizeOnDisk (theResource: Handle): LONGINT;
	inline
		$A9A5;

	function GetMaxResourceSize (theResource: Handle): LONGINT;
	inline
		$A821;

	procedure RemoveResource (theResource: Handle);
	inline
		$A9AD;

	function GetNextFOND (fondHandle: Handle): Handle;
	inline
		$700A, $A822;

implementation
end.