unit StandardFile;

{ Pascal Interface to the Macintosh Libraries }

{ Copyright  Apple Computer Inc. }
{ All Rights Reserved }

{ Adapted for use with THINK Pascal 4.0.x by Marco Piovanelli }

interface
	uses
		Types;

	type

{ for CustomXXXFile, ActivationOrderListPtr parameter is a pointer to an array of item numbers }
		ActivationOrderListPtr = ^INTEGER;

		DlgHookProcPtr = ProcPtr;  { FUNCTION DlgHook(item: INTEGER; theDialog: DialogPtr): INTEGER; }
		FileFilterProcPtr = ProcPtr;  { FUNCTION FileFilter(pb: CInfoPBPtr): BOOLEAN; }
		DlgHookYDProcPtr = ProcPtr;  { FUNCTION DlgHookYD(item: INTEGER; theDialog: DialogPtr; yourDataPtr: UNIV Ptr): INTEGER; }
		ModalFilterYDProcPtr = ProcPtr;  { FUNCTION ModalFilterYD(theDialog: DialogPtr; VAR theEvent: EventRecord; VAR itemHit: INTEGER; yourDataPtr: UNIV Ptr): BOOLEAN; }
		FileFilterYDProcPtr = ProcPtr;  { FUNCTION FileFilterYD(pb: CInfoPBPtr; yourDataPtr: UNIV Ptr): BOOLEAN; }
		ActivateYDProcPtr = ProcPtr;  { PROCEDURE ActivateYD(theDialog: DialogPtr; itemNo: INTEGER; activating: BOOLEAN; yourDataPtr: UNIV Ptr); }
		DlgHookUPP = UniversalProcPtr;
		FileFilterUPP = UniversalProcPtr;
		DlgHookYDUPP = UniversalProcPtr;
		ModalFilterYDUPP = UniversalProcPtr;
		FileFilterYDUPP = UniversalProcPtr;
		ActivateYDUPP = UniversalProcPtr;

	const
		uppDlgHookProcInfo = $000003A0; { FUNCTION (2 byte param, 4 byte param): 2 byte result; }
		uppFileFilterProcInfo = $000000D0; { FUNCTION (4 byte param): 1 byte result; }
		uppDlgHookYDProcInfo = $00000FA0; { FUNCTION (2 byte param, 4 byte param, 4 byte param): 2 byte result; }
		uppModalFilterYDProcInfo = $00003FD0; { FUNCTION (4 byte param, 4 byte param, 4 byte param, 4 byte param): 1 byte result; }
		uppFileFilterYDProcInfo = $000003D0; { FUNCTION (4 byte param, 4 byte param): 1 byte result; }
		uppActivateYDProcInfo = $000036C0; { PROCEDURE (4 byte param, 2 byte param, 1 byte param, 4 byte param); }

	function NewDlgHookProc (userRoutine: DlgHookProcPtr): DlgHookUPP;
	inline
		$2E9F;

	function NewFileFilterProc (userRoutine: FileFilterProcPtr): FileFilterUPP;
	inline
		$2E9F;

	function NewDlgHookYDProc (userRoutine: DlgHookYDProcPtr): DlgHookYDUPP;
	inline
		$2E9F;

	function NewModalFilterYDProc (userRoutine: ModalFilterYDProcPtr): ModalFilterYDUPP;
	inline
		$2E9F;

	function NewFileFilterYDProc (userRoutine: FileFilterYDProcPtr): FileFilterYDUPP;
	inline
		$2E9F;

	function NewActivateYDProc (userRoutine: ActivateYDProcPtr): ActivateYDUPP;
	inline
		$2E9F;

	function CallDlgHookProc (item: INTEGER;
									theDialog: DialogPtr;
									userRoutine: DlgHookUPP): INTEGER;
	inline
		$205F, $4E90;

	function CallFileFilterProc (pb: CInfoPBPtr;
									userRoutine: FileFilterUPP): BOOLEAN;
	inline
		$205F, $4E90;

	function CallDlgHookYDProc (item: INTEGER;
									theDialog: DialogPtr;
									yourDataPtr: univ Ptr;
									userRoutine: DlgHookYDUPP): INTEGER;
	inline
		$205F, $4E90;

	function CallModalFilterYDProc (theDialog: DialogPtr;
									var theEvent: EventRecord;
									var itemHit: INTEGER;
									yourDataPtr: univ Ptr;
									userRoutine: ModalFilterYDUPP): BOOLEAN;
	inline
		$205F, $4E90;

	function CallFileFilterYDProc (pb: CInfoPBPtr;
									yourDataPtr: univ Ptr;
									userRoutine: FileFilterYDUPP): BOOLEAN;
	inline
		$205F, $4E90;

	procedure CallActivateYDProc (theDialog: DialogPtr;
									itemNo: INTEGER;
									activating: BOOLEAN;
									yourDataPtr: univ Ptr;
									userRoutine: ActivateYDUPP);
	inline
		$205F, $4E90;

implementation
end.