unit Types;

{ Pascal Interface to the Macintosh Libraries }

{ Copyright  Apple Computer Inc. }
{ All Rights Reserved }

{ Adapted for use with THINK Pascal 4.0.x by Marco Piovanelli }

interface

	type

		UInt8 = Byte;
		SInt8 = SignedByte;
		UInt16 = INTEGER;
		SInt16 = INTEGER;
		UInt32 = LONGINT;
		SInt32 = LONGINT;

		UniChar = UInt16;
		ByteParameter = SignedByte;

		_extended80 = record
				exp: INTEGER;
				man: array[0..3] of INTEGER;
			end;

		_extended96 = record
				exp: array[0..1] of INTEGER;
				man: array[0..3] of INTEGER;
			end;

{$IFC OPTION(MC68881) }

		extended80 = _extended80;
		extended96 = extended;

{$ELSEC}

		extended80 = extended;
		extended96 = _extended96;

{$ENDC}

		float_t = extended;
		double_t = extended;

		Wide = record
				hi: SInt32;
				lo: UInt32;
			end;
		WidePtr = ^wide;

		UnsignedWide = record
				hi: UInt32;
				lo: UInt32;
			end;
		UnsignedWidePtr = ^UnsignedWide;

	type

		Register68kProcPtr = ProcPtr;

		ProcHandle = ^ProcPtr;

		UniversalProcPtr = ProcPtr;
		UniversalProcHandle = ^ProcPtr;

		CStringPtr = Ptr;
		ConstCStringPtr = Ptr;

		ConstStr255Param = Str255;
		ConstStr63Param = Str63;
		ConstStr32Param = Str32;
		ConstStr31Param = Str31;
		ConstStr27Param = Str27;
		ConstStr15Param = Str15;

		FourCharCode = packed array[1..4] of Char;

		NumVersion = packed record
				majorRev: UInt8;									{1st part of version number in BCD}
				minorAndBugRev: UInt8;									{2nd & 3rd part of version number share a byte}
				stage: UInt8;									{stage code: dev, alpha, beta, final}
				nonRelRev: UInt8;									{revision level of non-released version}
			end;

		VersRec = record
				numericVersion: NumVersion;								{encoded version number}
				countryCode: INTEGER;								{country code from intl utilities}
				shortVersion: Str255;									{version number string - worst case}
				reserved: Str255;									{longMessage string packed after shortVersion}
			end;
		VersRecPtr = ^VersRec;
		VersRecHndl = ^VersRecPtr;

		KernelID = Ptr;

		OSStatus = SInt32;

		LogicalAddress = Ptr;


	procedure Debugger68k;
	inline
		$A9FF;

	procedure DebugStr68k (debuggerMsg: ConstStr255Param);
	inline
		$ABFF;

	procedure SysBreak;
	inline
		$303C, $FE16, $A9C9;

	procedure SysBreakStr (debuggerMsg: ConstStr255Param);
	inline
		$303C, $FE15, $A9C9;

	procedure SysBreakFunc (debuggerMsg: ConstStr255Param);
	inline
		$303C, $FE14, $A9C9;

implementation
end.