unit WELongCoords;

{ WASTE PROJECT: }
{ Long Coordinates: data types and function prototypes }

{ Copyright  1993-1995 Marco Piovanelli }
{ All Rights Reserved }

interface
	uses
		Types;

	type

		LongPt = record
				case Integer of
					0: (
						v: LongInt;
						h: LongInt;
					);
					1: (
						vh: array[0..1] of LongInt;
					);
			end;  { LongPt }

		LongRect = record
				case Integer of
					0: (
						top: LongInt;
						left: LongInt;
						bottom: LongInt;
						right: LongInt;
					);
					1: (
						topLeft: LongPt;
						botRight: LongPt;
					);
			end;  { LongRect }

	function _WEPinInRange (value: LongInt;
									rangeStart, rangeEnd: LongInt): LongInt;
	procedure WELongPointToPoint ({const} var lp: LongPt;
									var p: Point);
	procedure WEPointToLongPoint (p: Point;
									var lp: LongPt);
	procedure WESetLongRect (var lr: LongRect;
									left, top, right, bottom: LongInt);
	procedure WELongRectToRect ({const} var lr: LongRect;
									var r: Rect);
	procedure WERectToLongRect ({const} var r: Rect;
									var lr: LongRect);
	procedure WEOffsetLongRect (var lr: LongRect;
									hOffset, vOffset: LongInt);
	function WELongPointInLongRect ({const} var lp: LongPt;
									{const} var lr: LongRect): Boolean;

implementation

	const
	
		kQDMax = maxint;
		kQDMin = -kQDMax;

	function _WEPinInRange(value: LongInt;
									rangeStart, rangeEnd: LongInt): LongInt;
	begin
		if (value > rangeEnd) then
			_WEPinInRange := rangeEnd
		else if (value < rangeStart) then
			_WEPinInRange := rangeStart
		else
			_WEPinInRange := value;
	end;  { _WEPinInRange }
	
	procedure WELongPointToPoint({const} var lp: LongPt; var p: Point);
	begin
		p.h := _WEPinInRange(lp.h, kQDMin, kQDMax);
		p.v := _WEPinInRange(lp.v, kQDMin, kQDMax);
	end;  { WELongPointToPoint }
	
	procedure WEPointToLongPoint(p: Point; var lp: LongPt);
	begin
		lp.h := p.h;
		lp.v := p.v;
	end;  { WEPointToLongPoint }
	
	procedure WESetLongRect (var lr: LongRect; left, top, right, bottom: LongInt);
	begin
		lr.top := top;
		lr.left := left;
		lr.bottom := bottom;
		lr.right := right;
	end;  { WESetLongRect }
	
	procedure WELongRectToRect({const} var lr: LongRect; var r: Rect);
	begin
		WELongPointToPoint(lr.topLeft, r.topLeft);
		WELongPointToPoint(lr.botRight, r.botRight);
	end;  { WELongRectToRect }

	procedure WERectToLongRect({const} var r: Rect; var lr: LongRect);
	begin
		lr.top := r.top;
		lr.left := r.left;
		lr.bottom := r.bottom;
		lr.right := r.right;
	end;  { WERectToLongRect }

	procedure WEOffsetLongRect (var lr: LongRect;
									hOffset, vOffset: LongInt);
	begin
		lr.top := lr.top + vOffset;
		lr.left := lr.left + hOffset;
		lr.bottom := lr.bottom + vOffset;
		lr.right := lr.right + hOffset;
	end;  { WEOffsetLongRect }

	function WELongPointInLongRect ({const} var lp: LongPt;
									{const} var lr: LongRect): Boolean;
	begin
		WELongPointInLongRect := (lp.v >= lr.top) & (lp.v < lr.bottom) & (lp.h >= lr.left) & (lp.h < lr.right);
	end;  { WELongPointInLongRect }

end.